/*
		    GNU GENERAL PUBLIC LICENSE
		       Version 2, June 1991

 Copyright (C) 1989, 1991 Free Software Foundation, Inc.,
 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 Everyone is permitted to copy and distribute verbatim copies
 of this license document, but changing it is not allowed.

			    Preamble

  The licenses for most software are designed to take away your
freedom to share and change it.  By contrast, the GNU General Public
License is intended to guarantee your freedom to share and change free
software--to make sure the software is free for all its users.  This
General Public License applies to most of the Free Software
Foundation's software and to any other program whose authors commit to
using it.  (Some other Free Software Foundation software is covered by
the GNU Lesser General Public License instead.)  You can apply it to
your programs, too.

  When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it
in new free programs; and that you know you can do these things.

  To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

  For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

  We protect your rights with two steps: (1) copyright the software, and
(2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

  Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

  Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

  The precise terms and conditions for copying, distribution and
modification follow.

		    GNU GENERAL PUBLIC LICENSE
   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

  0. This License applies to any program or other work which contains
a notice placed by the copyright holder saying it may be distributed
under the terms of this General Public License.  The "Program", below,
refers to any such program or work, and a "work based on the Program"
means either the Program or any derivative work under copyright law:
that is to say, a work containing the Program or a portion of it,
either verbatim or with modifications and/or translated into another
language.  (Hereinafter, translation is included without limitation in
the term "modification".)  Each licensee is addressed as "you".

Activities other than copying, distribution and modification are not
covered by this License; they are outside its scope.  The act of
running the Program is not restricted, and the output from the Program
is covered only if its contents constitute a work based on the
Program (independent of having been made by running the Program).
Whether that is true depends on what the Program does.

  1. You may copy and distribute verbatim copies of the Program's
source code as you receive it, in any medium, provided that you
conspicuously and appropriately publish on each copy an appropriate
copyright notice and disclaimer of warranty; keep intact all the
notices that refer to this License and to the absence of any warranty;
and give any other recipients of the Program a copy of this License
along with the Program.

You may charge a fee for the physical act of transferring a copy, and
you may at your option offer warranty protection in exchange for a fee.

  2. You may modify your copy or copies of the Program or any portion
of it, thus forming a work based on the Program, and copy and
distribute such modifications or work under the terms of Section 1
above, provided that you also meet all of these conditions:

    a) You must cause the modified files to carry prominent notices
    stating that you changed the files and the date of any change.

    b) You must cause any work that you distribute or publish, that in
    whole or in part contains or is derived from the Program or any
    part thereof, to be licensed as a whole at no charge to all third
    parties under the terms of this License.

    c) If the modified program normally reads commands interactively
    when run, you must cause it, when started running for such
    interactive use in the most ordinary way, to print or display an
    announcement including an appropriate copyright notice and a
    notice that there is no warranty (or else, saying that you provide
    a warranty) and that users may redistribute the program under
    these conditions, and telling the user how to view a copy of this
    License.  (Exception: if the Program itself is interactive but
    does not normally print such an announcement, your work based on
    the Program is not required to print an announcement.)

These requirements apply to the modified work as a whole.  If
identifiable sections of that work are not derived from the Program,
and can be reasonably considered independent and separate works in
themselves, then this License, and its terms, do not apply to those
sections when you distribute them as separate works.  But when you
distribute the same sections as part of a whole which is a work based
on the Program, the distribution of the whole must be on the terms of
this License, whose permissions for other licensees extend to the
entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest
your rights to work written entirely by you; rather, the intent is to
exercise the right to control the distribution of derivative or
collective works based on the Program.

In addition, mere aggregation of another work not based on the Program
with the Program (or with a work based on the Program) on a volume of
a storage or distribution medium does not bring the other work under
the scope of this License.

  3. You may copy and distribute the Program (or a work based on it,
under Section 2) in object code or executable form under the terms of
Sections 1 and 2 above provided that you also do one of the following:

    a) Accompany it with the complete corresponding machine-readable
    source code, which must be distributed under the terms of Sections
    1 and 2 above on a medium customarily used for software interchange; or,

    b) Accompany it with a written offer, valid for at least three
    years, to give any third party, for a charge no more than your
    cost of physically performing source distribution, a complete
    machine-readable copy of the corresponding source code, to be
    distributed under the terms of Sections 1 and 2 above on a medium
    customarily used for software interchange; or,

    c) Accompany it with the information you received as to the offer
    to distribute corresponding source code.  (This alternative is
    allowed only for noncommercial distribution and only if you
    received the program in object code or executable form with such
    an offer, in accord with Subsection b above.)

The source code for a work means the preferred form of the work for
making modifications to it.  For an executable work, complete source
code means all the source code for all modules it contains, plus any
associated interface definition files, plus the scripts used to
control compilation and installation of the executable.  However, as a
special exception, the source code distributed need not include
anything that is normally distributed (in either source or binary
form) with the major components (compiler, kernel, and so on) of the
operating system on which the executable runs, unless that component
itself accompanies the executable.

If distribution of executable or object code is made by offering
access to copy from a designated place, then offering equivalent
access to copy the source code from the same place counts as
distribution of the source code, even though third parties are not
compelled to copy the source along with the object code.

  4. You may not copy, modify, sublicense, or distribute the Program
except as expressly provided under this License.  Any attempt
otherwise to copy, modify, sublicense or distribute the Program is
void, and will automatically terminate your rights under this License.
However, parties who have received copies, or rights, from you under
this License will not have their licenses terminated so long as such
parties remain in full compliance.

  5. You are not required to accept this License, since you have not
signed it.  However, nothing else grants you permission to modify or
distribute the Program or its derivative works.  These actions are
prohibited by law if you do not accept this License.  Therefore, by
modifying or distributing the Program (or any work based on the
Program), you indicate your acceptance of this License to do so, and
all its terms and conditions for copying, distributing or modifying
the Program or works based on it.

  6. Each time you redistribute the Program (or any work based on the
Program), the recipient automatically receives a license from the
original licensor to copy, distribute or modify the Program subject to
these terms and conditions.  You may not impose any further
restrictions on the recipients' exercise of the rights granted herein.
You are not responsible for enforcing compliance by third parties to
this License.

  7. If, as a consequence of a court judgment or allegation of patent
infringement or for any other reason (not limited to patent issues),
conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License.  If you cannot
distribute so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you
may not distribute the Program at all.  For example, if a patent
license would not permit royalty-free redistribution of the Program by
all those who receive copies directly or indirectly through you, then
the only way you could satisfy both it and this License would be to
refrain entirely from distribution of the Program.

If any portion of this section is held invalid or unenforceable under
any particular circumstance, the balance of the section is intended to
apply and the section as a whole is intended to apply in other
circumstances.

It is not the purpose of this section to induce you to infringe any
patents or other property right claims or to contest validity of any
such claims; this section has the sole purpose of protecting the
integrity of the free software distribution system, which is
implemented by public license practices.  Many people have made
generous contributions to the wide range of software distributed
through that system in reliance on consistent application of that
system; it is up to the author/donor to decide if he or she is willing
to distribute software through any other system and a licensee cannot
impose that choice.

This section is intended to make thoroughly clear what is believed to
be a consequence of the rest of this License.

  8. If the distribution and/or use of the Program is restricted in
certain countries either by patents or by copyrighted interfaces, the
original copyright holder who places the Program under this License
may add an explicit geographical distribution limitation excluding
those countries, so that distribution is permitted only in or among
countries not thus excluded.  In such case, this License incorporates
the limitation as if written in the body of this License.

  9. The Free Software Foundation may publish revised and/or new versions
of the General Public License from time to time.  Such new versions will
be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.

Each version is given a distinguishing version number.  If the Program
specifies a version number of this License which applies to it and "any
later version", you have the option of following the terms and conditions
either of that version or of any later version published by the Free
Software Foundation.  If the Program does not specify a version number of
this License, you may choose any version ever published by the Free Software
Foundation.

  10. If you wish to incorporate parts of the Program into other free
programs whose distribution conditions are different, write to the author
to ask for permission.  For software which is copyrighted by the Free
Software Foundation, write to the Free Software Foundation; we sometimes
make exceptions for this.  Our decision will be guided by the two goals
of preserving the free status of all derivatives of our free software and
of promoting the sharing and reuse of software generally.

			    NO WARRANTY

  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
REPAIR OR CORRECTION.

  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
POSSIBILITY OF SUCH DAMAGES.

		     END OF TERMS AND CONDITIONS

	    How to Apply These Terms to Your New Programs

  If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these terms.

  To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.

    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Also add information on how to contact you by electronic and paper mail.

If the program is interactive, make it output a short notice like this
when it starts in an interactive mode:

    Gnomovision version 69, Copyright (C) year name of author
    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
    This is free software, and you are welcome to redistribute it
    under certain conditions; type `show c' for details.

The hypothetical commands `show w' and `show c' should show the appropriate
parts of the General Public License.  Of course, the commands you use may
be called something other than `show w' and `show c'; they could even be
mouse-clicks or menu items--whatever suits your program.

You should also get your employer (if you work as a programmer) or your
school, if any, to sign a "copyright disclaimer" for the program, if
necessary.  Here is a sample; alter the names:

  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
  `Gnomovision' (which makes passes at compilers) written by James Hacker.

  <signature of Ty Coon>, 1 April 1989
  Ty Coon, President of Vice

This General Public License does not permit incorporating your program into
proprietary programs.  If your program is a subroutine library, you may
consider it more useful to permit linking proprietary applications with the
library.  If this is what you want to do, use the GNU Lesser General
Public License instead of this License.
*/
#ifndef LIB_CARDS_INCLUDED
#define LIB_CARDS_INCLUDED


#include <string>
#include <set>

namespace cards {

class pkg
{	

	std::string 			m_description;
	std::string 			m_url;
	std::string 			m_maintainer;
	std::string 			m_packager;
	std::string 			m_contributors;

	std::string 			m_version;
	unsigned short int		m_release;

	std::set<std::string>   m_libs;
	std::set<std::string> 	m_alias;
	std::set<std::string> 	m_sets;
	std::set<std::string> 	m_categories;
	std::set<std::string>   m_conflicts;

	std::string				m_group;
	std::string				m_baseName;
	std::string				m_collection;
	std::string 			m_arch;
	std::string 			m_license;
	std::string 			m_signature;
	std::string 			m_origin;
	std::string 			m_branch;

	std::string 			m_hash;
	time_t 					m_build;


public:
	pkg();
	~pkg();
	const std::string&		description();
	const std::string&		url();
	const std::string& 		maintainer();
	const std::string&		packager();
	const std::string&		contributors();

	const std::string& 		version();
	unsigned short int 		release();

	const std::string&		group();
	const std::string&		baseName();
	const std::string&		collection();
	const std::set<std::string>&    libs();
	const std::set<std::string>& 	alias();
	const std::set<std::string>& 	sets();
	const std::set<std::string>&	categories();
	const std::set<std::string>&    conflicts();
	const std::string& 		arch();
	const std::string& 		license();
	const std::string&		signature();
	const std::string&		origin();
	const std::string&		branch();
	const std::string&		hash();
	time_t					build();

	void					description(const std::string& description);
	void					url(const std::string& url);
	void					maintainer(const std::string& maintainer);
	void					packager(const std::string& packager);
	void					contributors(const std::string& contributors);

	void					version(const std::string& version);
	void					release(unsigned short int release);

	void					libs(const std::set<std::string>& libs);
	void					alias(const std::set<std::string>& alias);
	void					sets(const std::set<std::string>& sets);
	void					categories(const std::set<std::string>& categories);
	void					conflicts(const std::set<std::string>& conflicts);

	void					collection(const std::string& collection);
	void					baseName(const std::string& baseName);
	void					group(const std::string& group);
	void					arch(const std::string& arch);
	void					license(const std::string& license);
	void					signature(const std::string& signature);
	void					hash(const std::string& hash);
	void					origin(const std::string& origin);
	void					branch (const std::string& branch);
	void					build(time_t time);

};

} //end of 'cards' namespace



namespace cards {

class db : public pkg
{
	unsigned int			m_space;      // disk occupation onces installed
	time_t					m_install;    // date of last installation
	bool					m_dependency; // If TRUE it's automatically installed, it's a dep

	std::set<std::pair<std::string,time_t>>
							m_dependencies;

public:
	db();
	~db();
	
	time_t 					install();
	unsigned int 			space();
	bool 					dependency();
	std::set<std::string>	files;
	std::set<std::pair<std::string,time_t>>&
							dependencies();

	void					install(time_t time);
	void					space(unsigned int space); 
	void					dependency(bool dependency);
	void					dependencies(const std::set<std::pair<std::string,time_t>> dependencies);

};

} //end of 'cards' namespace


#define _ gettext

#define INIT_ARCHIVE(ar)                     \
    archive_read_support_filter_gzip((ar));  \
    archive_read_support_filter_bzip2((ar)); \
    archive_read_support_filter_xz((ar));    \
    archive_read_support_filter_zstd((ar));  \
    archive_read_support_format_tar((ar))
#define FREE_ARCHIVE(ar) \
    archive_read_free((ar))

#define RED "\033[1;31m"
#define GREEN "\033[1;32m"
#define YELLOW "\033[1;33m"
#define BLUE "\033[1;34m"
#define MAGENTA "\033[1;35m"
#define CYAN "\033[1;36m"
#define WHITE "\033[1;37m"
#define NORMAL "\033[1;0m"

#define HELP_ACTION _("\033[1;33maction:\033[1;0m")
#define HELP_USAGE _("\033[1;33musage: \033[1;0m")
#define HELP_OPTIONS _("\033[1;33moptions\033[1;0m")
#define HELP_REQUIRED _("\033[1;33mrequired\033[1;0m")
#define HELP_DESCRIPTION _("\033[1;33mdescription: \033[1;0m")
#define HELP_COMMAND _("\033[1;34mcommand\033[1;0m")

#define CARDS_CONF_FILE "/etc/cards.conf"
#define NUTYX_VERSION_FILE "/var/lib/pkg/nutyx-version"
#define PRIVATEKEY "/.private.key"
#define PUBLICKEY "/.PKEY"

#define GIGA 1e9
#define MEGA 1e6
#define KILO 1e3
#define PACKAGE_LOCALE_DIR "/usr/share/locale"
#define GETTEXT_PACKAGE "cards"

#define uint8 unsigned char
#define uint32 unsigned long int

#define DEFAULT_BYTES_PER_BLOCK (20 * 512)
#define METAFILE ".META"
#define INFOFILE ".INFO"
#define MTREEFILE ".MTREE"



#define NAME 'N'
#define VERSION 'V'
#define RELEASE 'r'
#define SPACE 'S'
#define ARCHITECTURE 'a'
#define DESCRIPTION  'D'
#define URL 'U'
#define CONTRIBUTORS 'C'
#define MAINTAINER 'M'
#define PACKAGER 'P'
#define LICENSE 'L'
#define BUILD 'B'
#define COLLECTION 'c'
#define GROUP 'g'
#define SHARED_LIB 'l'
#define ALIAS 'A'
#define SETS 's'
#define CATEGORIES 'T'
#define HASHSUM 'H'
#define SIGNATURE 'I'
#define SIZE 'i'
#define CONFLICTS 'o'



#define LDCONFIG "sbin/ldconfig"
#define LDCONFIG_CONF "etc/ld.so.conf"
#define LDCONFIG_CONF_ARGS "-r "
#define SHELL "bin/sh"

#define INSTALL_INFO "usr/bin/install-info"
#define INSTALL_INFO_ARGS "--info-dir=usr/share/info "

#define UPDATE_ICON "usr/bin/gtk-update-icon-cache"
#define UPDATE_ICON_ARGS "-f -t "

#define COMPILE_SCHEMAS "usr/bin/glib-compile-schemas"
#define COMPILE_SCHEMAS_ARGS ""

#define UPDATE_DESKTOP_DB "usr/bin/update-desktop-database"
#define UPDATE_DESKTOP_DB_ARGS "-q "

#define UPDATE_MIME_DB "usr/bin/update-mime-database"
#define UPDATE_MIME_DB_ARGS "-n "

#define GDK_PIXBUF_QUERY_LOADER "usr/bin/gdk-pixbuf-query-loaders"
#define GDK_PIXBUF_QUERY_LOADER_ARGS "--update-cache"

#define GIO_QUERYMODULES "usr/bin/gio-querymodules"
#define GIO_QUERYMODULES_ARGS "usr/lib/gio/modules"

#define QUERY_IMMODULES_3 "usr/bin/gtk-query-immodules-3.0"
#define QUERY_IMMODULES_3_ARGS "--update-cache"

#define QUERY_IMMODULES_2 "usr/bin/gtk-query-immodules-2.0"
#define QUERY_IMMODULES_2_ARGS "--update-cache"

#define MKFONTDIR "usr/bin/mkfontdir"
#define MKFONTDIR_ARGS ""

#define MKFONTSCALE "usr/bin/mkfontscale"
#define MKFONTSCALE_ARGS ""

#define FC_CACHE "usr/bin/fc-cache"
#define FC_CACHE_ARGS ""

#define MAX_BUFFER 50
#define MARGIN 20



namespace cards {

enum ErrorEnum {
	ERROR_ENUM_CANNOT_FIND_DEPOT,
	ERROR_ENUM_CANNOT_DOWNLOAD_FILE,
	ERROR_ENUM_CANNOT_CREATE_FILE,
	ERROR_ENUM_CANNOT_OPEN_FILE,
	ERROR_ENUM_CANNOT_FIND_FILE,
	ERROR_ENUM_CANNOT_READ_FILE,
	ERROR_ENUM_CANNOT_COPY_FILE,
	ERROR_ENUM_CANNOT_PARSE_FILE,
	ERROR_ENUM_CANNOT_READ_DIRECTORY,
	ERROR_ENUM_CANNOT_CHANGE_DIRECTORY,
	ERROR_ENUM_CANNOT_WRITE_FILE,
	ERROR_ENUM_CANNOT_SYNCHRONIZE,
	ERROR_ENUM_CANNOT_RENAME_FILE,
	ERROR_ENUM_CANNOT_DETERMINE_NAME_BUILDNR,
	ERROR_ENUM_WRONG_ARCHITECTURE,
	ERROR_ENUM_EMPTY_PACKAGE,
	ERROR_ENUM_CANNOT_FORK,
	ERROR_ENUM_WAIT_PID_FAILED,
	ERROR_ENUM_DATABASE_LOCKED,
	ERROR_ENUM_CANNOT_LOCK_DIRECTORY,
	ERROR_ENUM_CANNOT_REMOVE_FILE,
	ERROR_ENUM_CANNOT_CREATE_DIRECTORY,
	ERROR_ENUM_CANNOT_RENAME_DIRECTORY,
	ERROR_ENUM_OPTION_ONE_ARGUMENT,
	ERROR_ENUM_INVALID_OPTION,
	ERROR_ENUM_OPTION_MISSING,
	ERROR_ENUM_TOO_MANY_OPTIONS,
	ERROR_ENUM_ONLY_ROOT_CAN_INSTALL_UPGRADE_REMOVE,
	ERROR_ENUM_PACKAGE_IN_USE,
	ERROR_ENUM_PACKAGE_NOT_EXIST,
	ERROR_ENUM_PACKAGE_NOT_FOUND,
	ERROR_ENUM_PACKAGE_ALLREADY_INSTALL,
	ERROR_ENUM_PACKAGE_NOT_INSTALL,
	ERROR_ENUM_PACKAGE_NOT_PREVIOUSLY_INSTALL,
	ERROR_ENUM_LISTED_FILES_ALLREADY_INSTALLED,
	ERROR_ENUM_PKGADD_CONFIG_LINE_TOO_LONG,
	ERROR_ENUM_PKGADD_CONFIG_WRONG_NUMBER_ARGUMENTS,
	ERROR_ENUM_PKGADD_CONFIG_UNKNOWN_ACTION,
	ERROR_ENUM_PKGADD_CONFIG_UNKNOWN_EVENT,
	ERROR_ENUM_CANNOT_COMPILE_REGULAR_EXPRESSION,
	ERROR_ENUM_NOT_IN_CHROOT,
	ERROR_ENUM_CANNOT_GENERATE_LEVEL,
	ERROR_ENUM_NOT_INSTALL_PACKAGE_NEITHER_PACKAGE_FILE,
	ERROR_ENUM_PRIVATE_KEY_PATH_NOT_DEFINE,
	ERROR_ENUM_PUBLIC_KEY_NOT_EXIST,
	ERROR_ENUM_CANNOT_GENERATE_PRIVATE_KEY,
	ERROR_ENUM_CANNOT_SAVE_PRIVATE_KEY,
	ERROR_ENUM_CANNOT_CHMOD_PRIVATE_KEY_TO_600,
	ERROR_ENUM_CANNOT_SAVE_PUBLIC_KEY,
	ERROR_ENUM_WRONG_SIGNATURE
};

enum StatusEnumUpgrade {
	STATUS_ENUM_UPG_OK,
	STATUS_ENUM_UPG_UNMAINT,
	STATUS_ENUM_UPG_OBSOLET,
	STATUS_ENUM_UPG_REPLACE,
	STATUS_ENUM_UPG_CONFLICT,
	STATUS_ENUM_UPG_OUTOFDATE,
	STATUS_ENUM_UPG_NEWBUILD
};
enum StatusEnum {
	STATUS_ENUM_UNKNOWN = 0x00,
	STATUS_ENUM_INSTALLED = 0x01,
	STATUS_ENUM_TO_INSTALL = 0x02,
	STATUS_ENUM_TO_REMOVE = 0x04,
	STATUS_ENUM_TO_UPGRADE = 0x08
};
enum ActionEnum {
	ACTION_ENUM_PKG_DOWNLOAD_START,
	ACTION_ENUM_PKG_DOWNLOAD_RUN,
	ACTION_ENUM_PKG_DOWNLOAD_END,
	ACTION_ENUM_DB_OPEN_START,
	ACTION_ENUM_DB_OPEN_RUN,
	ACTION_ENUM_DB_OPEN_END,
	ACTION_ENUM_PKG_PREINSTALL_START,
	ACTION_ENUM_PKG_PREINSTALL_END,
	ACTION_ENUM_PKG_INSTALL_START,
	ACTION_ENUM_PKG_INSTALL_END,
	ACTION_ENUM_PKG_INSTALL_RUN,
	ACTION_ENUM_PKG_POSTINSTALL_START,
	ACTION_ENUM_PKG_POSTINSTALL_END,
	ACTION_ENUM_PKG_MOVE_META_START,
	ACTION_ENUM_PKG_MOVE_META_END,
	ACTION_ENUM_DB_ADD_PKG_START,
	ACTION_ENUM_DB_ADD_PKG_END,
	ACTION_ENUM_LDCONFIG_START,
	ACTION_ENUM_LDCONFIG_END,
	ACTION_ENUM_RM_PKG_FILES_START,
	ACTION_ENUM_RM_PKG_FILES_RUN,
	ACTION_ENUM_RM_PKG_FILES_END
};
enum RuleEnum {
	RULE_ENUM_LDCONF,
	RULE_ENUM_UPGRADE,
	RULE_ENUM_INSTALL,
	RULE_ENUM_INFO,
	RULE_ENUM_ICONS,
	RULE_ENUM_FONTS,
	RULE_ENUM_SCHEMAS,
	RULE_ENUM_DESKTOP_DB,
	RULE_ENUM_MIME_DB,
	RULE_ENUM_QUERY_PIXBUF,
	RULE_ENUM_GIO_QUERY,
	RULE_ENUM_QUERY_IMOD3,
	RULE_ENUM_QUERY_IMOD2
};
enum rule_event_t {
	LDCONF,
	UPGRADE,
	INSTALL,
	INFO,
	ICONS,
	FONTS,
	SCHEMAS,
	DESKTOP_DB,
	MIME_DB,
	QUERY_PIXBUF,
	GIO_QUERY,
	QUERY_IMOD3,
	QUERY_IMOD2
};
enum archive_error {
    CANNOT_OPEN_ARCHIVE,
    CANNOT_READ_ARCHIVE,
    CANNOT_FIND_META_FILE,
    CANNOT_FIND_MTREE_FILE,
    CANNOT_FIND_NAME,
    CANNOT_FIND_ARCH,
    EMPTY_ARCHIVE
};

} // end of cards namespace




namespace cards {

class cache: public db
{
	StatusEnum			m_status;
	unsigned int long   m_size;
	bool				m_installed;
	std::string			m_name;
	std::string			m_fileName;
	std::string			m_fileDate;
	std::string			m_dirName;

public:
	cache();
	~cache();
	unsigned int long   size();
	StatusEnum			status();
	bool				installed();
	bool				toinstall();
	bool				toremove();
	const std::string&	name();
	const std::string&	fileName();
	const std::string&	fileDate();
	const std::string&	dirName();

	void				size(unsigned int long size);
	void				setStatus(StatusEnum status);
	void				unsetStatus(StatusEnum status);
	void				installed(bool installed);
	void				name(const std::string& name);
	void				fileName(const std::string& fileName);
	void				fileDate(const std::string& filedate);
	void				dirName(const std::string& dirname);


};

} // endof cards namespace



#include <iostream>
#include <iterator>
#include <string>

#include <cstring>
#include <libintl.h>
#include <locale.h>
#include <cstdio>
#include <sys/utsname.h>
#include <syslog.h>

/**
 Return the same as 'uname -m' commands
 */
std::string getMachineType();

void assertArgument(char** argv, int argc, int index);
void rotatingCursor();

class RunTimeErrorWithErrno : public std::runtime_error
{
	public:
		explicit RunTimeErrorWithErrno(const std::string& msg) throw();
		explicit RunTimeErrorWithErrno(const std::string& msg, int e) throw();
};




#include <fstream>
#include <map>
#include <set>
#include <vector>
#include <list>

#include <sys/stat.h>

typedef std::map<std::string, std::string> alias_t;

struct keyValue 
{
	std::string parameter;
	std::string value;
};

/**
 * splitKeyValue: Split a string value into a keyValue structure
 *
 */
keyValue splitKeyValue
(std::string s, char delimiter);

std::set<std::string> getKeysList
(std::string file, std::string delimiter);

std::string getValueOfKey
(std::string file, std::string delimiter,std::string parameter);

std::string getValue(const std::string& s, char delimiter);
std::string getValueBefore( const std::string& s, char del );
std::string getValueBeforeLast( const std::string& s, char del );

std::string itos(unsigned int value);
std::string ultos(unsigned long int value);

std::string mtos(mode_t mode);
std::string trimFileName(const std::string& filename);
std::string sizeHumanRead(unsigned long value);

/*param s the string to be searched, param delimiter the delimiter char 
return the value after the first occurance of a delimiter */
std::string getFirstValueOfKeyAfterDelim
(const std::string& s, char delimiter);

/* strip whitespace in the beginning and end of string, return a stripped string */
std::string stripWhiteSpace(const std::string& s);

/* populate a vector container of string with delimited characters */
std::vector<std::string> parseDelimitedVectorList
(const std::string& s, const char *delimiter);

/* populate a vector container of string with a delimited character */
const std::vector<std::string> parseDelimitedVectorList
(const std::string& s, const char& c);

/* populate a list container of string with a delimited character */
const std::list<std::string> parseDelimitedListList
(const std::string& s, const char& c);

/* populate a set container of string with delimited characters */
std::set<std::string> parseDelimitedSetList
(const std::string& s, const char *delimiter);

/* make sure s1 starts with s2 */
bool startsWith(const std::string& s, const std::string& with);

/**
 startsWithNoCase
 make sure s1 starts with s2
*/
bool startsWithNoCase(const std::string& s1, const std::string& s2);

std::string convertToLowerCase(const std::string& s);
std::string convertToUpperCase(const std::string& s);

std::string replaceAll
( std::string& in, const std::string& oldString, const std::string& newString );



#include <dirent.h>
#include <err.h>
#include <libgen.h>
#include <sys/file.h>
#include <sys/param.h>
#include <unistd.h>
#include <utime.h>

#define S_CARDS_MODE 0755

#define WS_NONE 0
#define WS_RECURSIVE (1 << 0)
#define WS_DEFAULT WS_RECURSIVE
#define WS_FOLLOWLINK (1 << 1) /* follow symlinks */
#define WS_DOTFILES (1 << 2) /* per unix convention, .file is hidden */
#define WS_MATCHDIRS (1 << 3) /* if pattern is used on dir names too */

enum {
    WALK_OK = 0,
    WALK_BADPATTERN,
    WALK_NAMETOOLONG,
    WALK_BADIO
};

struct InfoFile {
    std::string url;
    std::string filename;
    std::string dirname;
    std::string hash;
    long int filetime;
    utimbuf acmodtime;
    FILE* stream;
};
void* getDatas(void* var, FILE* file, long offset, size_t size, size_t nmemb);
std::string trimFileName(const std::string& filename);
time_t getEpochModifyTimeFile(const std::string& filename);
std::string getDateFromEpoch(const time_t& epoch);
std::string getModifyTimeFile(const std::string& filename);
bool checkFileExist(const std::string& filename);
bool checkFileEmpty(const std::string& filename);
bool checkRegularFile(const std::string& filename);
bool checkFileHash(const std::string& filename, const std::string& hash);
bool checkFilesEqual(const std::string& file1, const std::string& file2);
bool checkPermissionsEqual(const std::string& file1, const std::string& file2);
bool createRecursiveDirs(const std::string& pathname);
void cleanupMetaFiles(const std::string& basedir);
void removeFile(const std::string& basedir, const std::string& filename);
int copyFile(const char* destFile, const char* origFile);
int findDir(std::set<std::string>& filesList, const std::string& basedir);
int findRecursiveFile(std::set<std::string>& filenameList, const char* filename, int spec);
int parseFile(std::set<std::string>& fileContent, const char* fileName);
int parseFile(std::vector<std::string>& fileContent, const char* fileName);
int parseFile(std::string& Depends, const char* key, const char* fileName);




#include <archive.h>
#include <archive_entry.h>

class archive {

	unsigned int long        m_size;

	std::string              m_fileName;
	std::string              m_packageName;
	std::string              m_packageArch;

	std::vector<std::string> m_contentMtree;
	std::vector<std::string> m_contentMeta;

	std::set<std::string>    m_rtDependenciesList;
	std::set<std::string>    m_filesList;
	std::set<std::string>    m_aliasList;
	std::set<std::string>    m_categoriesList;
	std::set<std::string>    m_setsList;

	cards::archive_error     m_actualError;

	std::set<std::pair<std::string, time_t>>
	                         m_rtDependenciesEpochList;


	void getRunTimeDependencies();
	void getRunTimeDependenciesEpoch();
	void getAliasList();
	void getCategoriesList();
	void getSetsList();

public:
	archive(const std::string& fileName);
	virtual ~archive();

	virtual void treatErrors(const std::string& s) const;

	// Print Out the dependencies
	void printDeps();

	// Print Out the .META file
	void printMeta();

	// Return Meta data
	const std::vector<std::string>& contentMeta();

	// list the files to stdio
	void list();

	std::string getPackageName();
	std::string getPackageArch();
	void extractFileContent(std::vector<std::string>& list, const char* fileName);

	// Numbers of files in the archive
	unsigned int long size();

	std::set<std::string> setofFiles();
	std::set<std::string> listofDependencies();
	std::set<std::string> listofAlias();
	std::set<std::string> listofCategories();
	std::set<std::string> listofSets();

	// return an order set of dependencies,BuildDate
	std::set<std::pair<std::string, time_t>> listofDependenciesBuildDate();
	std::string arch();
	std::string version();
	int         release();
	std::string description();
	std::string url();
	std::string contributors();
	std::string maintainer();
	std::string collection();
	std::string license();
	std::string packager();

	// return the date like Mon Mar 24 10:16:00 2014
	std::string builddate();

	std::string name();
	std::string group();

	// return the name + epochvalue
	std::string namebuildn();

	// return the epochvalue in string format
	std::string epochBuildDate();

	// return the epoch value
	time_t build();

};




namespace cards {

struct DirUrl {
    std::string collection;
    std::string depot;
    std::string url;
};

class conf {

    std::string m_filename;
    std::string m_name;
    std::string m_version;
    std::string m_arch;
    std::string m_depot;
    std::string m_url;
    std::string m_keypath;
    std::string m_dir;
    std::string m_logdir;
    std::string m_username;
    std::string m_hostname;
    std::string m_database;
    std::string m_password;

    std::vector<std::string> m_groups;
    std::vector<std::string> m_urls;
    std::vector<std::string> m_collections;
    std::vector<std::string> m_depots;
    std::vector<std::string> m_archs;
    std::vector<DirUrl>      m_dirUrl;
    std::vector<DirUrl>      m_sysconf;
    std::vector<DirUrl>      m_userconf;

    void parseConfig();

public:

    conf(const std::string& filename);
    ~conf();

    const std::string& version();
    const std::string& url();
    const std::string& keypath();
    const std::string& hostname();
    const std::string& username();
    const std::string& password();
    const std::string& database();
    const std::string& arch();
    const std::string& depot();
    const std::string& logdir();

    std::vector<std::string>& groups();
    std::vector<std::string>& urls();
    std::vector<std::string>& depots();
    std::vector<std::string>& collections();
    std::vector<DirUrl>&      dirUrl();
};

} // endof cards namespace



#include <cstddef>
#include <stdexcept>
#include <dirent.h>
#include <sys/file.h>
#include <csignal>

namespace cards {
class lock {
public:
	lock(const std::string& m_root, bool exclusive);
	~lock();

private:
	DIR* m_dir;
	struct sigaction m_sa;
};

} // end of cards namespace



#include <zstd.h>

namespace cards {
class sync
{
	std::string m_pkgRepoFile;
	std::string m_pkgFilesFile;
	std::string m_root;
	std::string m_configFile;

	cards::conf m_config;
	void        uncompress(std::string fileName);

public:
	sync();
	sync(const std::string configFile);

	void        run();
	void        purge();

	static const std::string DEFAULT_PKG_REPO;
	static const std::string DEFAULT_PKG_FILES;
};

}



namespace cards {

class port : public pkg {

    // The index Name used to check
    // if dependencies is valid
    unsigned int    m_index;

    // The level of dependency:
    // 0: No dependency
    // 1: some deps from level 0 dependencies
    // 2: some deps from level 1 dependencies
    // 3: ... 2  ...
    // etc
    int             m_level;

    // number of removed dependencies
    // when searching them
    unsigned int m_decrement;

    // number of dependencies that are still
    // need to be treated
    int             m_decount;

    // Dependencies made of index Name
    // This list validate all the dependencies
    // as they are pointing the actual name via
    // they index
    std::vector<unsigned int>
                    m_indexes;

    std::set<std::string>
                    m_dependencies;

public:
    port()
        : m_level(0)
        , m_decount(0)
        , m_decrement(0)
    {
    }
    int level()
    {
        return m_level;
    }
    void level(int level)
    {
        m_level = level;
    }
    int decount()
    {
        return m_decount;
    }
    void decount(int decount)
    {
        m_decount = decount;
    }
    unsigned int index()
    {
        return m_index;
    }
    void index(unsigned int index)
    {
        m_index = index;
    }
    unsigned int decrement()
    {
        return m_decrement;
    }
    void decrement(unsigned int decrement)
    {
        m_decrement = decrement;
    }
    std::vector<unsigned int> indexes()
    {
        return m_indexes;
    }
    void indexes(std::vector<unsigned int>& indexes)
    {
        m_indexes = indexes;
    }
    std::set<std::string> dependencies()
    {
        return m_dependencies;
    }
    void dependencies(const std::set<std::string>& dependencies)
    {
        m_dependencies = dependencies;
    }
};

typedef std::map<std::string, cards::port> ports_t;

class pkgfile {

    std::string                 m_configFileName;
    cards::conf                 m_config;
    ports_t                     m_listOfPackages;
    std::vector<std::string>    m_listOfPackagesFromCollection;
    std::vector<std::string>    m_badDependencies;
    unsigned int                m_level;

    void                        parse();
    void                        generate_level();
    std::string                 getVariable(const std::string& file,
        const std::string& name);

public:
    pkgfile(const std::string& fileName);
    virtual ~pkgfile() { }

    /**
     * Get the level of the portName
     *
     */
    int                        getLevel(const std::string& portName);

    /**
     * check that all the dependencies exist in each package
     *
     */
    void                        confirmDependencies();


    std::vector<std::string>&   getListOfPackagesFromCollection(std::string collectionName);

    /**
     * return the set of dependencies of the port name
     *
     */
    std::set<std::string>       getDependencies(const std::string& portName);

    /**
     * return the version of the port name
     *
     */
    std::string                getPortVersion(const std::string& portName);

    /**
     * return the folder of the port name
     *
     */
    std::string                getPortDir(const std::string& portName);

    /**
     * return the release of the port name
     *
     */
    unsigned short int          getPortRelease(const std::string& portName);

    /**
     * return true if port name exist
     *
     */
    bool                        checkPackageNameExist(const std::string& name);

    /**
     * return true if it's collection
     *
     */
    bool                        checkCollectionNameExist(const std::string& name);
    /**
     * return the list of found Packages
     *
     */
    ports_t&                    getListOfPackages();

    /**
     * return the list of bad Dependencies
     *
     */
    std::vector<std::string>&   badDependencies();
};

} // end of 'cards' namespace


#include <curl/curl.h>

namespace cards {


/**
 * \brief File Download State class
 *
 * This class provide container to provide progress update datas
 * to client who suscribe to the progress event
 *
 */

class dwlState
{
	public:

		double dlnow;
		double dltotal;
		double dlspeed;
		std::string filename;
};

class dwl;

/**
 * \brief File Download Event class
 *
 * This abstract class provide inherit definition for a callback
 * suscriber to be callable by dwl Progress Update
 *
 */

class dwlEvent
{
		friend dwl;

	protected:

		/**
		 * Callback called when new progress data are available
		 *
		 * \param state Class container datas for current download
		 */
		virtual void OndwlProgressInfo(dwlState state){};

	public:

		dwlEvent();
		~dwlEvent();

};

/**
 * \brief File Download class
 *
 * This class takes care of the download process of the binaries and
 * other important files
 *
 */

class dwl
{
		bool			m_progress;
		std::string		m_url;
		std::string		m_downloadFileName;
		std::string		m_fileInfo;

		CURL*			m_curl;
		CURLcode		m_curlCode;
		/**
		* download effectively the request file
		*/
		void get();

		static int updateProgressHandle(void *p,
			curl_off_t dltotal,
			curl_off_t dlnow,
			curl_off_t ultotal,
			curl_off_t ulnow);

		static size_t writeToStreamHandle(void *buffer,
			size_t size,
			size_t nmemb,
			void *stream);

		int updateProgress(void *p,
			curl_off_t dltotal,
			curl_off_t dlnow,
			curl_off_t ultotal,
			curl_off_t ulnow);

		size_t writeToStream(void *buffer,
			size_t size,
			size_t nmemb,
			void *stream);

		void initFileToDownload(std::string _url,
			std::string _file);

		void SendProgressEvent(dwlState event);

		struct dwlProgress
		{
			std::string name;
			double lastruntime;
			CURL *curl;
		};

		struct curl_slist *m_slist;

		dwlProgress	m_downloadProgress;
		InfoFile	m_destinationFile;

		static std::set<dwlEvent*> m_arrCallBacks;

	public:

		/**
		* Constructor
		* Download a file
		*
		* \param url Complete downloading address including the file
		* \param dirName Destination folder
		* \param fileName file where to store the downloaded datas
		* \param progress If true, show what's going on
		*/
		dwl(std::string url,
			std::string dirName,
			std::string fileName,
			bool progress);

		/**
		* Constructor
		* Download a list of InfoFile (a vector of InfoFile type)
		* InfoFile consist of (amount other fields.. ) Name of the file and the signature of the file to download
		*
		* \param destinationFiles List of files to download
		* \param progress If true, show what's going on
		*/
		dwl(std::vector<InfoFile> destinationFiles,
			bool progress);

		/**
		* Destructor need to cleanup all the created pointers for the internal cook
		*/
		~dwl()
		{
			curl_slist_free_all(m_slist);
			curl_global_cleanup();
			curl_easy_cleanup(m_curl);
		}

		static void SuscribeToEvents(dwlEvent* callback);
		static void UnSuscribeFromEvents(dwlEvent* callback);
};
} // end of 'cards' namespace



#include <cassert>
#include <cstddef>
#include <cstdlib>

#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/wait.h>

  
/**
  * To execute a process
	* Arguments:
	* 1. Application to run
	* 2. Arguments to pass to the application
	* 3. File descriptor of the log file
*/

class process
{
	std::string m_application;
	std::string m_arguments;
	int         m_fileDescriptorLog;

	int         exec(const int argc, char** argv);
	int         execLog(const int argc, char** argv);

	int         execShell(const char* shell);
	int         execShellLog(const char* shell);

public:
	process();
	process(const std::string& app,
		const std::string& args,
		int fileDescriptorLog=0 );

	void execute(const std::string& app,
		const std::string& arguments,
		int fileDescriptorLog=0  );

	/**
		* execute the process
		* return the exit status of the application
		*/
	int execute();

	/**
		*  execute the process using the shell
		*  return the exit status of the application
		*/
	int executeShell();

	/**
		*  return the name of the application
		*/
	std::string name();

	/**
		*  return the arguments of the application
		*/
	std::string args();

};



#include <sys/stat.h>


int getRuntimeLibrariesList (std::set<std::string>& runtimeLibrariesList,
		const std::string& filename);




#include <algorithm>

#include <ext/stdio_filebuf.h>
#include <grp.h>
#include <pwd.h>
#include <regex.h>

typedef std::map<std::string, cards::db> packages_t;

struct rule_t {
    cards::rule_event_t event;
    std::string pattern;
    bool action;
};

class pkgdbh {

    std::set<std::string>   m_filesList;
    std::set<std::string>   m_listOfPackagesNames;

    unsigned int            m_filesNumber;
    unsigned int            m_installedFilesNumber;

    bool                    m_dependency;
    bool                    m_DB_Empty;

    void                    runLastPostInstall();
    void                    getListOfPackagesNames();
    std::string             getSingleItem(const std::string& PackageName, const char i) const;

    std::set<std::string>   getSetOfItems(const std::string& PackageName, const char i) const;

protected:
    // Database

    void                    buildSimpleDependenciesDatabase();

    void                    addPackageFilesRefsToDB(const std::string& name,
                                const cards::db& info);

    void                    addPackagesFilesRefsToDB();
    void                    addPackagesMetaRefsToDB();
    /**
     * Remove the physical files after followings some rules
     */
    void                    removePackageFiles(const std::string& name);
    void                    removePackageFiles(const std::string& name,
                                const std::set<std::string>& keep_list);

    /**
     * Remove meta data about the removed package
     */
    void                    removePackageFilesRefsFromDB(const std::string& name);
    void                    removePackageFilesRefsFromDB(std::set<std::string> files,
                                const std::set<std::string>& keep_list);

    std::set<std::string>   getConflictsFilesList(const std::string& name, cards::db& info);

    // Archive Package handling
    std::pair<std::string, cards::db>
                            openArchivePackage(const std::string& filename);
    void                    extractAndRunPREfromPackage(const std::string& filename);
    void                    installArchivePackage(const std::string& filename,
                                const std::set<std::string>& keep_list,
                                const std::set<std::string>& non_install_files);

    /**
     * The folder holding the meta datas is going to be create here
     */
    void                    moveMetaFilesPackage(const std::string& name, cards::db& info);

    const void              readRulesFile();
    void                    getInstallRulesList(const std::vector<rule_t>& rules,
                                cards::rule_event_t event, std::vector<rule_t>& found) const;

    bool                    checkRuleAppliesToFile(const rule_t& rule,
                                const std::string& file);

    void                    getFootprintPackage(std::string& filename);

    bool                    m_progress;
    std::string             m_packageName;
    std::string             m_packageArchiveVersion;
    std::string             m_packageArchiveRelease;
    std::string             m_packageArchiveCollection;
    std::string             m_packageVersion;
    std::string             m_packageRelease;
    std::string             m_packageCollection;
    std::string             m_utilName;
    std::string             m_root;
    std::vector<rule_t>     m_actionRules;
    std::set<std::pair<std::string, int>>
                            m_postInstallList;
    alias_t                 m_listOfAlias;

    packages_t              m_listOfPackages;

    std::set<std::pair<std::string, std::set<std::string>>>
                            m_listOfPackagesWithDeps;

    cards::ActionEnum       m_actualAction;
    cards::ErrorEnum        m_actualError;

public:
    /**
     * Constructors
    */
    explicit                pkgdbh(const std::string& name);
    explicit                pkgdbh();

    /**
     * Destructor
    */
    virtual                 ~pkgdbh();

    /**
     *  Following methods can be redefined in derivated class
     *
     */
    virtual void            parseArguments(int argc, char** argv);
    virtual void            run(int argc, char** argv);
    virtual void            run() {};
    virtual void            printHelp() const {};
    virtual void            progressInfo();
    virtual void            progressInfo(cards::ActionEnum action);
    virtual void            treatErrors(const std::string& s) const;

    void                    print_version() const;
    void                    buildDatabase(const bool& files);
    void                    setDependency();
    void                    resetDependency();

    std::set<std::string>&  getSetOfPackagesNames();
    std::string             getDescription(const std::string& name) const;
    std::string             getVersion(const std::string& name) const;
    std::string             getCollection(const std::string& name) const;
    std::string             getSets(const std::string& name) const;
    std::set<std::string>   getSetOfSets(const std::string& name) const;
    std::string             getArch(const std::string& name) const;
    std::string             getLicense(const std::string& name) const;
    std::string             getCategories(const std::string& name) const;
    std::set<std::string>   getSetOfCategories(const std::string& name) const;
    std::set<std::string>   getSetOfFiles(const std::string& packageName);
    std::set<std::string>   getSetOfFiles();

    const unsigned int      getNumberOfPackages();
    const unsigned int      getNumberOfFiles();
    unsigned int            getInstalledFilesNumber();
    unsigned int            getSize(const std::string& name) const;
    unsigned int            getRelease(const std::string& name) const;

    bool                    checkPackageNameUptodate(archive& archiveName);
    bool                    checkPackageNameUptodate(std::pair<std::string, cards::db>& archiveName);
    bool                    checkPackageNameBuildDateSame(const std::pair<std::string,time_t>& dependencieNameBuild);
    bool                    checkPackageNameExist(const std::string& name) const;
    bool                    checkFileNameExist(const std::string& name);
    bool                    checkDependency(const std::string& name);

};



/**
 * \brief pkgadd class
 *
 * This class takes care of adding binaries package into the database
 *
 */

class pkgadd : public pkgdbh {

	void			applyPostInstallRules(const std::string& name,
						cards::db& info,
						const std::vector<rule_t>& rules);

	void			getInstallRulesList(const std::vector<rule_t>& rules,
						cards::rule_event_t event,
						std::vector<rule_t>& found) const;

	void 			getPostInstallRulesList(const std::vector<rule_t>& rules,
						std::vector<rule_t>& found) const;

protected:
	std::string 	m_packageArchiveName;
	bool 			m_runPrePost;
	bool 			m_upgrade;
	bool 			m_force;
	std::set<std::string>
					applyInstallRules(const std::string& name,
						cards::db& info,
						const std::vector<rule_t>& rules);
	std::set<std::string>
					getKeepFileList(const std::set<std::string>& files,
						const std::vector<rule_t>& rules);

public:
	/**
	 * Default constructor without any argument
	 */
	pkgadd();
	/**
	 * Alternative constructor for derivated classes
	 * 
	 * \param commandName Name of the command used in derivated class
	 */
	pkgadd(const std::string& commandName);

	void				parseArguments(int argc, char** argv);
	void				preRun();
	void				postRun();
	virtual void        run();
	virtual void        printHelp() const;
};



class pkgrm : public pkgdbh {

	void getDirectDependencies(std::string& name);

protected:
	void getListOfManInstalledPackages ();
	std::set<std::string> m_listOfManInstalledPackages;
	std::set<std::string> m_listofDependencies;

public:
	pkgrm(const std::string& commandName) : pkgdbh(commandName) {}
	pkgrm();
	void run();
	void printHelp() const;


};



#include <iomanip>
#include <sstream>

class pkginfo : public pkgdbh {

protected:
    std::string     m_arg;
    int             m_runtimedependencies_mode;
    int             m_runtimelibs_mode;
    int             m_footprint_mode;
    int             m_archiveinfo;
    int             m_metainfo;
    int             m_installed_mode;
    int             m_number_mode;
    int             m_list_mode;
    int             m_owner_mode;
    int             m_details_mode;
    int             m_libraries_mode;
    int             m_runtime_mode;
    int             m_epoc;
    bool            m_fulllist_mode;

public:
    pkginfo(const std::string& commandName);
    pkginfo();

    virtual void    parseArguments(int argc, char** argv);
    void            installed();
    void            list(const std::string& packageName);
    void            query(const std::string& fileName);
    void            details(const std::string& packageName);
    virtual void    run();
    virtual void    finish();
    virtual void    printHelp() const;

};



#include <iomanip>

#include <openssl/pem.h>
#include <openssl/err.h>

namespace cards {

typedef std::map<std::string, cards::cache> repo_t;

struct m_package {
	std::string description;
	std::string collection;
	time_t installed_build;
	time_t available_build;
	std::string installed_version;
	std::string available_version;
	unsigned int installed_space;
	unsigned int available_space;
          unsigned int available_size;
	StatusEnumUpgrade status;

};

class pkgrepo {

    std::string              m_packageName;
    std::string              m_configFileName;
    cards::ErrorEnum         m_actualError;
    cards::conf              m_config;
    repo_t                   m_listOfPackages;
    packages_t               m_listOfRepoPackages;

    pkgdbh                   m_dbh;

    std::set<std::string>    m_binaryLibsList;
    std::set<std::string>    m_binarySetList;
    std::set<std::string>    m_binaryCollectionList;
    std::set<std::string>    m_binaryGroupList;
    std::set<std::string>    m_binaryPackageList;

    std::string              m_binaryPackageInfo;
    std::string              m_packageDirName;
    std::string              m_packageFileName;
    std::string              m_packageFileNameSignature;
    std::string              m_packageFileNameHash;
    std::string              m_packageVersion;

    std::vector<std::pair<std::string,time_t>>
                             m_dependenciesList;

    void                     treatErrors(const std::string& s) const;
    void                     parse();
    void                     errors();

public:
    pkgrepo(const std::string& fileName);
    virtual ~pkgrepo() { ERR_free_strings(); }

    void                     generateDependencies(const std::pair<std::string,time_t>& packageName);
    void                     generateDependencies();
    void                     generateDependencies(const std::string& packageName);
    void                     downloadPackageFileName(const std::string& packageName);

    std::set<std::pair<std::string,time_t>>
                             getPackageDependencies (const std::string& filename);

    bool                     checkBinaryExist(const std::string& name);

    // To check the validity of an archive
    //
    // 1. generateHash(filename("gcc")); m_packageFileHash is set
    //
    // 2. checkHash("gcc"); m_packageFileHash is compared with the hash found in the DB
    //
    // Return True if matching.

    // Generate the hashsum for the archive file of the package name and store the result
    // in the m_packageFileNameHash member variable
    void                     generateHash(const std::string& packageName);

    // Store the computed hash stored in m_packageFileNameHash
    // into the database packageName hash property
    void                     hash(const std::string& packageName);

    // Check the Hash and signature of the archive file of the package name
    bool                     checkHash(const std::string& name);

    // Return the m_packageNameFileNameHash value
    std::string&            hash();

    // To generate hash and signature
    //
    // 1. std::string packageName = getName("gcc.cards-11.2-1.xz");
    // 2. generateHash("gcc.cards-11.2-1.xz");  m_packageFileNameHash is set

    // 3. hash(packageName);
    // 4. generateSign(hash());
    // 5. sign(packageName);

    // OR

    // 1. std::string packageName = getName("gcc.cards-11.2-1.xz");
    // 2. generateHash("gcc.cards-11.2-1.xz"); m_packageFileNameHash is set
    // 3. generateSign(); m_packageFileNameHas is used and signed
    // 4. hash(packageName)
    // 5. sign(packageName)
    // Infos stored in the DB

    // Generate the signature of the hashsum stored in the m_packageFileNameHash
    // member variable
    void                     generateSign();

    // Generate the signature of the hashsum for the archive file of the package name
    // and store the result in the m_packageFileNameSignature member variable
    // The private key location is defined in cards.conf file.
    void                     generateSign(const std::string& hash);

    // Store the computed signature stored in m_packageFileNameSignature
    // into the database packageName signature property
    void                    sign(const std::string& packageName);

    // Return the m_packageNameFileNameSignature value
    std::string&            sign();

    // Check the signature of the hashsum of an archive file of the package name
    // The public key location is at the root of the repository or collection
    bool                     checkSign(const std::string& name);

    // Generate the keys pair for signing and verifying the package archive hashing
    void                     generateKeys();

    void                     refresh();
    time_t                   getBinaryBuildTime (const std::string& name);

    std::string&             dirName(const std::string& name);
    std::string&             fileName(const std::string& name);
    std::string&             fileSignature(const std::string& name);
    std::string&             fileHash(const std::string& name);
    std::string&             getBinaryPackageInfo(const std::string& name);
    unsigned int             getSpace(const std::string& name);
    unsigned int             getSize(const std::string& name);
    std::string&             version(const std::string& name);
    unsigned short int       release(const std::string& name);

    std::vector<std::string> getListOfGroups();
    std::set<std::string>&   getListOfFiles(const std::string& name);
    std::set<std::string>    getLibs(const std::string& name);
    std::set<std::string>&   getBinaryPackageList();
    std::set<std::string>&   getListOfPackagesFromSet(const std::string& name);
    std::set<std::string>&   getListOfPackagesFromCollection(const std::string& name);
    std::set<std::string>&   getListOfPackagesFromGroup(const std::string& name);

    std::vector<std::pair<std::string,time_t>>&
                             getDependenciesList();
    void                     addDependenciesList(std::pair<std::string,time_t>& name);

    const repo_t&            getListOfPackages();
};

} // end of 'cards' namespace
#endif
